
package org.openbravo.erpWindows.SystemInfo;




import org.codehaus.jettison.json.JSONObject;
import org.openbravo.erpCommon.utility.*;
import org.openbravo.data.FieldProvider;
import org.openbravo.utils.FormatUtilities;
import org.openbravo.utils.Replace;
import org.openbravo.base.secureApp.HttpSecureAppServlet;
import org.openbravo.base.secureApp.VariablesSecureApp;
import org.openbravo.base.exception.OBException;
import org.openbravo.scheduling.ProcessBundle;
import org.openbravo.scheduling.ProcessRunner;
import org.openbravo.erpCommon.businessUtility.WindowTabs;
import org.openbravo.xmlEngine.XmlDocument;
import java.util.Vector;
import java.util.StringTokenizer;
import org.openbravo.database.SessionInfo;
import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.util.*;
import java.sql.Connection;
import org.apache.log4j.Logger;

public class SystemInfo extends HttpSecureAppServlet {
  private static final long serialVersionUID = 1L;
  
  private static Logger log4j = Logger.getLogger(SystemInfo.class);
  
  private static final String windowId = "578DD45CF2BF4D3CA27E4C0EEEF5E5E6";
  private static final String tabId = "8652BB9E40664869A5132CEB8A907B9B";
  private static final String defaultTabView = "EDIT";
  private static final int accesslevel = 4;
  private static final String moduleId = "0";
  
  @Override
  public void init(ServletConfig config) {
    setClassInfo("W", tabId, moduleId);
    super.init(config);
  }
  
  

  public void doPost (HttpServletRequest request, HttpServletResponse response) throws IOException,ServletException {
    TableSQLData tableSQL = null;
    VariablesSecureApp vars = new VariablesSecureApp(request);
    Boolean saveRequest = (Boolean) request.getAttribute("autosave");
    
    if(saveRequest != null && saveRequest){
      String currentOrg = vars.getStringParameter("inpadOrgId");
      String currentClient = vars.getStringParameter("inpadClientId");
      boolean editableTab = (!org.openbravo.erpCommon.utility.WindowAccessData.hasReadOnlyAccess(this, vars.getRole(), tabId)
                            && (currentOrg.equals("") || Utility.isElementInList(Utility.getContext(this, vars,"#User_Org", windowId, accesslevel), currentOrg)) 
                            && (currentClient.equals("") || Utility.isElementInList(Utility.getContext(this, vars, "#User_Client", windowId, accesslevel),currentClient)));
    
        OBError myError = new OBError();
        String commandType = request.getParameter("inpCommandType");
        String stradSystemInfoId = request.getParameter("inpadSystemInfoId");
        
        if (editableTab) {
          int total = 0;
          
          if(commandType.equalsIgnoreCase("EDIT") && !stradSystemInfoId.equals(""))
              total = saveRecord(vars, myError, 'U');
          else
              total = saveRecord(vars, myError, 'I');
          
          if (!myError.isEmpty() && total == 0)     
            throw new OBException(myError.getMessage());
        }
        vars.setSessionValue(request.getParameter("mappingName") +"|hash", vars.getPostDataHash());
        vars.setSessionValue(tabId + "|Header.view", "EDIT");
        
        return;
    }
    
    try {
      tableSQL = new TableSQLData(vars, this, tabId, Utility.getContext(this, vars, "#AccessibleOrgTree", windowId, accesslevel), Utility.getContext(this, vars, "#User_Client", windowId), Utility.getContext(this, vars, "ShowAudit", windowId).equals("Y"));
    } catch (Exception ex) {
      ex.printStackTrace();
    }

    String strOrderBy = vars.getSessionValue(tabId + "|orderby");
    if (!strOrderBy.equals("")) {
      vars.setSessionValue(tabId + "|newOrder", "1");
    }

    if (vars.commandIn("DEFAULT")) {

      String strAD_System_Info_ID = vars.getGlobalVariable("inpadSystemInfoId", windowId + "|AD_System_Info_ID", "");
      

      String strView = vars.getSessionValue(tabId + "|SystemInfo.view");
      if (strView.equals("")) {
        strView = defaultTabView;

        if (strView.equals("EDIT")) {
          if (strAD_System_Info_ID.equals("")) strAD_System_Info_ID = firstElement(vars, tableSQL);
          if (strAD_System_Info_ID.equals("")) strView = "RELATION";
        }
      }
      if (strView.equals("EDIT")) 

        printPageEdit(response, request, vars, false, strAD_System_Info_ID, tableSQL);

      else printPageDataSheet(response, vars, strAD_System_Info_ID, tableSQL);
    } else if (vars.commandIn("DIRECT")) {
      String strAD_System_Info_ID = vars.getStringParameter("inpDirectKey");
      
        
      if (strAD_System_Info_ID.equals("")) strAD_System_Info_ID = vars.getRequiredGlobalVariable("inpadSystemInfoId", windowId + "|AD_System_Info_ID");
      else vars.setSessionValue(windowId + "|AD_System_Info_ID", strAD_System_Info_ID);
      
      vars.setSessionValue(tabId + "|SystemInfo.view", "EDIT");

      printPageEdit(response, request, vars, false, strAD_System_Info_ID, tableSQL);

    } else if (vars.commandIn("TAB")) {


      String strView = vars.getSessionValue(tabId + "|SystemInfo.view");
      String strAD_System_Info_ID = "";
      if (strView.equals("")) {
        strView = defaultTabView;
        if (strView.equals("EDIT")) {
          strAD_System_Info_ID = firstElement(vars, tableSQL);
          if (strAD_System_Info_ID.equals("")) strView = "RELATION";
        }
      }
      if (strView.equals("EDIT")) {

        if (strAD_System_Info_ID.equals("")) strAD_System_Info_ID = firstElement(vars, tableSQL);
        printPageEdit(response, request, vars, false, strAD_System_Info_ID, tableSQL);

      } else printPageDataSheet(response, vars, "", tableSQL);
    } else if (vars.commandIn("SEARCH")) {
vars.getRequestGlobalVariable("inpParamSystem_Identifier", tabId + "|paramSystem_Identifier");
vars.getRequestGlobalVariable("inpParamOB_Version", tabId + "|paramOB_Version");

        vars.getRequestGlobalVariable("inpParamUpdated", tabId + "|paramUpdated");
        vars.getRequestGlobalVariable("inpParamUpdatedBy", tabId + "|paramUpdatedBy");
        vars.getRequestGlobalVariable("inpParamCreated", tabId + "|paramCreated");
        vars.getRequestGlobalVariable("inpparamCreatedBy", tabId + "|paramCreatedBy");
      
      
      vars.removeSessionValue(windowId + "|AD_System_Info_ID");
      String strAD_System_Info_ID="";

      String strView = vars.getSessionValue(tabId + "|SystemInfo.view");
      if (strView.equals("")) strView=defaultTabView;

      if (strView.equals("EDIT")) {
        strAD_System_Info_ID = firstElement(vars, tableSQL);
        if (strAD_System_Info_ID.equals("")) {
          // filter returns empty set
          strView = "RELATION";
          // switch to grid permanently until the user changes the view again
          vars.setSessionValue(tabId + "|SystemInfo.view", strView);
        }
      }

      if (strView.equals("EDIT")) 

        printPageEdit(response, request, vars, false, strAD_System_Info_ID, tableSQL);

      else printPageDataSheet(response, vars, strAD_System_Info_ID, tableSQL);
    } else if (vars.commandIn("RELATION")) {
      

      String strAD_System_Info_ID = vars.getGlobalVariable("inpadSystemInfoId", windowId + "|AD_System_Info_ID", "");
      vars.setSessionValue(tabId + "|SystemInfo.view", "RELATION");
      printPageDataSheet(response, vars, strAD_System_Info_ID, tableSQL);
    } else if (vars.commandIn("NEW")) {


      printPageEdit(response, request, vars, true, "", tableSQL);

    } else if (vars.commandIn("EDIT")) {

      @SuppressWarnings("unused") // In Expense Invoice tab this variable is not used, to be fixed
      String strAD_System_Info_ID = vars.getGlobalVariable("inpadSystemInfoId", windowId + "|AD_System_Info_ID", "");
      vars.setSessionValue(tabId + "|SystemInfo.view", "EDIT");

      setHistoryCommand(request, "EDIT");
      printPageEdit(response, request, vars, false, strAD_System_Info_ID, tableSQL);

    } else if (vars.commandIn("NEXT")) {

      String strAD_System_Info_ID = vars.getRequiredStringParameter("inpadSystemInfoId");
      
      String strNext = nextElement(vars, strAD_System_Info_ID, tableSQL);

      printPageEdit(response, request, vars, false, strNext, tableSQL);
    } else if (vars.commandIn("PREVIOUS")) {

      String strAD_System_Info_ID = vars.getRequiredStringParameter("inpadSystemInfoId");
      
      String strPrevious = previousElement(vars, strAD_System_Info_ID, tableSQL);

      printPageEdit(response, request, vars, false, strPrevious, tableSQL);
    } else if (vars.commandIn("FIRST_RELATION")) {

      vars.setSessionValue(tabId + "|SystemInfo.initRecordNumber", "0");
      response.sendRedirect(strDireccion + request.getServletPath() + "?Command=RELATION");
    } else if (vars.commandIn("PREVIOUS_RELATION")) {

      String strInitRecord = vars.getSessionValue(tabId + "|SystemInfo.initRecordNumber");
      String strRecordRange = Utility.getContext(this, vars, "#RecordRange", windowId);
      int intRecordRange = strRecordRange.equals("")?0:Integer.parseInt(strRecordRange);
      if (strInitRecord.equals("") || strInitRecord.equals("0")) {
        vars.setSessionValue(tabId + "|SystemInfo.initRecordNumber", "0");
      } else {
        int initRecord = (strInitRecord.equals("")?0:Integer.parseInt(strInitRecord));
        initRecord -= intRecordRange;
        strInitRecord = ((initRecord<0)?"0":Integer.toString(initRecord));
        vars.setSessionValue(tabId + "|SystemInfo.initRecordNumber", strInitRecord);
      }
      vars.removeSessionValue(windowId + "|AD_System_Info_ID");

      response.sendRedirect(strDireccion + request.getServletPath() + "?Command=RELATION");
    } else if (vars.commandIn("NEXT_RELATION")) {

      String strInitRecord = vars.getSessionValue(tabId + "|SystemInfo.initRecordNumber");
      String strRecordRange = Utility.getContext(this, vars, "#RecordRange", windowId);
      int intRecordRange = strRecordRange.equals("")?0:Integer.parseInt(strRecordRange);
      int initRecord = (strInitRecord.equals("")?0:Integer.parseInt(strInitRecord));
      if (initRecord==0) initRecord=1;
      initRecord += intRecordRange;
      strInitRecord = ((initRecord<0)?"0":Integer.toString(initRecord));
      vars.setSessionValue(tabId + "|SystemInfo.initRecordNumber", strInitRecord);
      vars.removeSessionValue(windowId + "|AD_System_Info_ID");

      response.sendRedirect(strDireccion + request.getServletPath() + "?Command=RELATION");
    } else if (vars.commandIn("FIRST")) {

      
      String strFirst = firstElement(vars, tableSQL);

      printPageEdit(response, request, vars, false, strFirst, tableSQL);
    } else if (vars.commandIn("LAST_RELATION")) {

      String strLast = lastElement(vars, tableSQL);
      printPageDataSheet(response, vars, strLast, tableSQL);
    } else if (vars.commandIn("LAST")) {

      
      String strLast = lastElement(vars, tableSQL);

      printPageEdit(response, request, vars, false, strLast, tableSQL);
    } else if (vars.commandIn("SAVE_NEW_RELATION", "SAVE_NEW_NEW", "SAVE_NEW_EDIT")) {

      OBError myError = new OBError();      
      int total = saveRecord(vars, myError, 'I');      
      if (!myError.isEmpty()) {        
        response.sendRedirect(strDireccion + request.getServletPath() + "?Command=NEW");
      } 
      else {
		if (myError.isEmpty()) {
		  myError = Utility.translateError(this, vars, vars.getLanguage(), "@CODE=RowsInserted");
		  myError.setMessage(total + " " + myError.getMessage());
		  vars.setMessage(tabId, myError);
		}        
        if (vars.commandIn("SAVE_NEW_NEW")) response.sendRedirect(strDireccion + request.getServletPath() + "?Command=NEW");
        else if (vars.commandIn("SAVE_NEW_EDIT")) response.sendRedirect(strDireccion + request.getServletPath() + "?Command=EDIT");
        else response.sendRedirect(strDireccion + request.getServletPath() + "?Command=RELATION");
      }
    } else if (vars.commandIn("SAVE_EDIT_RELATION", "SAVE_EDIT_NEW", "SAVE_EDIT_EDIT", "SAVE_EDIT_NEXT")) {

      String strAD_System_Info_ID = vars.getRequiredGlobalVariable("inpadSystemInfoId", windowId + "|AD_System_Info_ID");
      OBError myError = new OBError();
      int total = saveRecord(vars, myError, 'U');      
      if (!myError.isEmpty()) {
        response.sendRedirect(strDireccion + request.getServletPath() + "?Command=EDIT");
      } 
      else {
        if (myError.isEmpty()) {
          myError = Utility.translateError(this, vars, vars.getLanguage(), "@CODE=RowsUpdated");
          myError.setMessage(total + " " + myError.getMessage());
          vars.setMessage(tabId, myError);
        }
        if (vars.commandIn("SAVE_EDIT_NEW")) response.sendRedirect(strDireccion + request.getServletPath() + "?Command=NEW");
        else if (vars.commandIn("SAVE_EDIT_EDIT")) response.sendRedirect(strDireccion + request.getServletPath() + "?Command=EDIT");
        else if (vars.commandIn("SAVE_EDIT_NEXT")) {
          String strNext = nextElement(vars, strAD_System_Info_ID, tableSQL);
          vars.setSessionValue(windowId + "|AD_System_Info_ID", strNext);
          response.sendRedirect(strDireccion + request.getServletPath() + "?Command=EDIT");
        } else response.sendRedirect(strDireccion + request.getServletPath() + "?Command=RELATION");
      }
    } else if (vars.commandIn("DELETE")) {

      String strAD_System_Info_ID = vars.getRequiredStringParameter("inpadSystemInfoId");
      //SystemInfoData data = getEditVariables(vars);
      int total = 0;
      OBError myError = null;
      if (org.openbravo.erpCommon.utility.WindowAccessData.hasNotDeleteAccess(this, vars.getRole(), tabId)) {
        myError = Utility.translateError(this, vars, vars.getLanguage(), Utility.messageBD(this, "NoWriteAccess", vars.getLanguage()));
        vars.setMessage(tabId, myError);
      } else {
        try {
          total = SystemInfoData.delete(this, strAD_System_Info_ID, Utility.getContext(this, vars, "#User_Client", windowId, accesslevel), Utility.getContext(this, vars, "#User_Org", windowId, accesslevel));
        } catch(ServletException ex) {
          myError = Utility.translateError(this, vars, vars.getLanguage(), ex.getMessage());
          if (!myError.isConnectionAvailable()) {
            bdErrorConnection(response);
            return;
          } else vars.setMessage(tabId, myError);
        }
        if (myError==null && total==0) {
          myError = Utility.translateError(this, vars, vars.getLanguage(), Utility.messageBD(this, "NoWriteAccess", vars.getLanguage()));
          vars.setMessage(tabId, myError);
        }
        vars.removeSessionValue(windowId + "|adSystemInfoId");
        vars.setSessionValue(tabId + "|SystemInfo.view", "RELATION");
      }
      if (myError==null) {
        myError = Utility.translateError(this, vars, vars.getLanguage(), "@CODE=RowsDeleted");
        myError.setMessage(total + " " + myError.getMessage());
        vars.setMessage(tabId, myError);
      }
      response.sendRedirect(strDireccion + request.getServletPath());






    } else if (vars.commandIn("BUTTONProxy_Password")) {
        String strAD_System_Info_ID = vars.getGlobalVariable("inpadSystemInfoId", windowId + "|AD_System_Info_ID", "");
        
        printPageButtonProxy_Password(request, response, vars, strAD_System_Info_ID);

    } else if (vars.commandIn("SAVE_BUTTONProxy_Password")) {
        String strAD_System_Info_ID = vars.getGlobalVariable("inpKey", windowId + "|AD_System_Info_ID", "");
        String strProxy_Password = FormatUtilities.encryptDecrypt(vars.getStringParameter("inpValue"), true);



        OBError myError = null;
        int count = 0;
        try {
          count = SystemInfoData.updateproxyPassword(this, strProxy_Password, strAD_System_Info_ID);
        } catch(ServletException ex) {
          myError = Utility.translateError(this, vars, vars.getLanguage(), ex.getMessage());
          if (!myError.isConnectionAvailable()) {
            bdErrorConnection(response);
            return;
          } else vars.setMessage(tabId, myError);
        }
        if (myError==null) {
          myError = new OBError();
          if (count==0) {
            myError.setTitle(Utility.messageBD(this, "Error", vars.getLanguage()));
            myError.setType("Error");            
          } else {
            myError.setTitle(Utility.messageBD(this, "Success", vars.getLanguage()));
            myError.setType("Success");
          }
          vars.setMessage(tabId, myError);
        }
        if (log4j.isDebugEnabled() && myError!=null) log4j.debug(myError.getMessage());
        printPageClosePopUp(response, vars);

    } else if (vars.commandIn("SAVE_XHR")) {
      
      OBError myError = new OBError();
      JSONObject result = new JSONObject();
      String commandType = vars.getStringParameter("inpCommandType");
      char saveType = "NEW".equals(commandType) ? 'I' : 'U';
      try {
        int total = saveRecord(vars, myError, saveType);
        if (myError.isEmpty()) {
          myError = Utility.translateError(this, vars, vars.getLanguage(), "@CODE=RowsUpdated");
          myError.setMessage(total + " " + myError.getMessage());
          myError.setType("Success");
        }
        result.put("oberror", myError.toMap());
        result.put("tabid", vars.getStringParameter("tabID"));
        result.put("redirect", strDireccion + request.getServletPath() + "?Command=" + commandType);
      } catch (Exception e) {
        log4j.error("Error saving record (XHR request): " + e.getMessage(), e);
        myError.setType("Error");
        myError.setMessage(e.getMessage());
      }

      response.setContentType("application/json");
      PrintWriter out = response.getWriter();
      out.print(result.toString());
      out.flush();
      out.close();
    } else if (vars.getCommand().toUpperCase().startsWith("BUTTON") || vars.getCommand().toUpperCase().startsWith("SAVE_BUTTON")) {
      pageErrorPopUp(response);
    } else pageError(response);
  }
  private SystemInfoData getEditVariables(Connection con, VariablesSecureApp vars) throws IOException,ServletException {
    SystemInfoData data = new SystemInfoData();
    ServletException ex = null;
    try {
    data.codeRevision = vars.getStringParameter("inpcodeRevision");     data.antVersion = vars.getStringParameter("inpantVersion");     data.servletContainer = vars.getStringParameter("inpservletContainer");     data.servletContainerVersion = vars.getStringParameter("inpservletContainerVersion");     data.webserver = vars.getStringParameter("inpwebserver");     data.webserverVersion = vars.getStringParameter("inpwebserverVersion");     data.instancePurpose = vars.getStringParameter("inpinstancePurpose");     data.instancePurposer = vars.getStringParameter("inpinstancePurpose_R");     data.changeInstancePurpose = vars.getStringParameter("inpchangeInstancePurpose");     data.productionBannerImageId = vars.getStringParameter("inpproductionBannerImageId");     data.customizationAllowed = vars.getStringParameter("inpcustomizationAllowed", "N");     data.isusageauditenabled = vars.getStringParameter("inpisusageauditenabled", "N");     data.showCommunityBranding = vars.getStringParameter("inpshowCommunityBranding", "N");     data.systemStatus = vars.getStringParameter("inpsystemStatus");     data.systemStatusr = vars.getStringParameter("inpsystemStatus_R");     data.isproxyrequired = vars.getStringParameter("inpisproxyrequired", "N");     data.proxyServer = vars.getStringParameter("inpproxyServer");    try {   data.proxyPort = vars.getNumericParameter("inpproxyPort");  } catch (ServletException paramEx) { ex = paramEx; }     data.isproxyAuthenticated = vars.getStringParameter("inpisproxyAuthenticated", "N");     data.proxyUser = vars.getStringParameter("inpproxyUser");     data.proxyPassword = FormatUtilities.encryptDecrypt(vars.getStringParameter("inpproxyPassword"), true);     data.yourCompanyLoginImage = vars.getStringParameter("inpyourCompanyLoginImage");     data.yourcompanyurl = vars.getStringParameter("inpyourcompanyurl");     data.yourItServiceLoginImage = vars.getStringParameter("inpyourItServiceLoginImage");     data.supportContact = vars.getStringParameter("inpsupportContact");     data.yourCompanyMenuImage = vars.getStringParameter("inpyourCompanyMenuImage");     data.yourCompanyBigImage = vars.getStringParameter("inpyourCompanyBigImage");     data.yourCompanyDocumentImage = vars.getStringParameter("inpyourCompanyDocumentImage");     data.showforgelogo = vars.getStringParameter("inpshowforgelogo", "N");     data.lastBuild = vars.getStringParameter("inplastBuild");     data.adClientId = vars.getRequiredGlobalVariable("inpadClientId", windowId + "|AD_Client_ID");     data.adOrgId = vars.getRequiredGlobalVariable("inpadOrgId", windowId + "|AD_Org_ID");     data.adSystemInfoId = vars.getRequestGlobalVariable("inpadSystemInfoId", windowId + "|AD_System_Info_ID");     data.isactive = vars.getStringParameter("inpisactive", "N");     data.isheartbeatactive = vars.getStringParameter("inpisheartbeatactive");     data.obInstallmode = vars.getStringParameter("inpobInstallmode");     data.obVersion = vars.getStringParameter("inpobVersion");     data.postponeDate = vars.getStringParameter("inppostponeDate");     data.systemIdentifier = vars.getStringParameter("inpsystemIdentifier");     data.testproxy = vars.getRequiredStringParameter("inptestproxy");     data.dbChecksum = vars.getStringParameter("inpdbChecksum");     data.lastDbupdate = vars.getStringParameter("inplastDbupdate");     data.maturitySearch = vars.getRequiredStringParameter("inpmaturitySearch");     data.maturityUpdate = vars.getRequiredStringParameter("inpmaturityUpdate"); 
      data.createdby = vars.getUser();
      data.updatedby = vars.getUser();
      data.adUserClient = Utility.getContext(this, vars, "#User_Client", windowId, accesslevel);
      data.adOrgClient = Utility.getContext(this, vars, "#AccessibleOrgTree", windowId, accesslevel);
      data.updatedTimeStamp = vars.getStringParameter("updatedTimestamp");



          vars.getGlobalVariable("inpisops", windowId + "|ISOPS", "");
    
    

    
    }
    catch(ServletException e) {
    	vars.setEditionData(tabId, data);
    	throw e;
    }
    // Behavior with exception for numeric fields is to catch last one if we have multiple ones
    if(ex != null) {
      vars.setEditionData(tabId, data);
      throw ex;
    }
    return data;
  }




    private void refreshSessionEdit(VariablesSecureApp vars, FieldProvider[] data) {
      if (data==null || data.length==0) return;
          vars.setSessionValue(windowId + "|AD_Client_ID", data[0].getField("adClientId"));    vars.setSessionValue(windowId + "|AD_Org_ID", data[0].getField("adOrgId"));    vars.setSessionValue(windowId + "|AD_System_Info_ID", data[0].getField("adSystemInfoId"));
    }

    private void refreshSessionNew(VariablesSecureApp vars) throws IOException,ServletException {
      SystemInfoData[] data = SystemInfoData.selectEdit(this, vars.getSessionValue("#AD_SqlDateTimeFormat"), vars.getLanguage(), vars.getStringParameter("inpadSystemInfoId", ""), Utility.getContext(this, vars, "#User_Client", windowId), Utility.getContext(this, vars, "#AccessibleOrgTree", windowId, accesslevel));
      if (data==null || data.length==0) return;
      refreshSessionEdit(vars, data);
    }

  private String nextElement(VariablesSecureApp vars, String strSelected, TableSQLData tableSQL) throws IOException, ServletException {
    if (strSelected == null || strSelected.equals("")) return firstElement(vars, tableSQL);
    if (tableSQL!=null) {
      String data = null;
      try{
        String strSQL = ModelSQLGeneration.generateSQLonlyId(this, vars, tableSQL, (tableSQL.getTableName() + "." + tableSQL.getKeyColumn() + " AS ID"), new Vector<String>(), new Vector<String>(), 0, 0);
        ExecuteQuery execquery = new ExecuteQuery(this, strSQL, tableSQL.getParameterValuesOnlyId());
        data = execquery.selectAndSearch(ExecuteQuery.SearchType.NEXT, strSelected, tableSQL.getKeyColumn());
      } catch (Exception e) { 
        log4j.error("Error getting next element", e);
      }
      if (data!=null) {
        if (data!=null) return data;
      }
    }
    return strSelected;
  }

  private int getKeyPosition(VariablesSecureApp vars, String strSelected, TableSQLData tableSQL) throws IOException, ServletException {
    if (log4j.isDebugEnabled()) log4j.debug("getKeyPosition: " + strSelected);
    if (tableSQL!=null) {
      String data = null;
      try{
        String strSQL = ModelSQLGeneration.generateSQLonlyId(this, vars, tableSQL, (tableSQL.getTableName() + "." + tableSQL.getKeyColumn() + " AS ID"), new Vector<String>(), new Vector<String>(),0,0);
        ExecuteQuery execquery = new ExecuteQuery(this, strSQL, tableSQL.getParameterValuesOnlyId());
        data = execquery.selectAndSearch(ExecuteQuery.SearchType.GETPOSITION, strSelected, tableSQL.getKeyColumn());
      } catch (Exception e) { 
        log4j.error("Error getting key position", e);
      }
      if (data!=null) {
        // split offset -> (page,relativeOffset)
        int absoluteOffset = Integer.valueOf(data);
        int page = absoluteOffset / TableSQLData.maxRowsPerGridPage;
        int relativeOffset = absoluteOffset % TableSQLData.maxRowsPerGridPage;
        log4j.debug("getKeyPosition: absOffset: " + absoluteOffset + "=> page: " + page + " relOffset: " + relativeOffset);
        String currPageKey = tabId + "|" + "currentPage";
        vars.setSessionValue(currPageKey, String.valueOf(page));
        return relativeOffset;
      }
    }
    return 0;
  }

  private String previousElement(VariablesSecureApp vars, String strSelected, TableSQLData tableSQL) throws IOException, ServletException {
    if (strSelected == null || strSelected.equals("")) return firstElement(vars, tableSQL);
    if (tableSQL!=null) {
      String data = null;
      try{
        String strSQL = ModelSQLGeneration.generateSQLonlyId(this, vars, tableSQL, (tableSQL.getTableName() + "." + tableSQL.getKeyColumn() + " AS ID"), new Vector<String>(), new Vector<String>(),0,0);
        ExecuteQuery execquery = new ExecuteQuery(this, strSQL, tableSQL.getParameterValuesOnlyId());
        data = execquery.selectAndSearch(ExecuteQuery.SearchType.PREVIOUS, strSelected, tableSQL.getKeyColumn());
      } catch (Exception e) { 
        log4j.error("Error getting previous element", e);
      }
      if (data!=null) {
        return data;
      }
    }
    return strSelected;
  }

  private String firstElement(VariablesSecureApp vars, TableSQLData tableSQL) throws IOException, ServletException {
    if (tableSQL!=null) {
      String data = null;
      try{
        String strSQL = ModelSQLGeneration.generateSQLonlyId(this, vars, tableSQL, (tableSQL.getTableName() + "." + tableSQL.getKeyColumn() + " AS ID"), new Vector<String>(), new Vector<String>(),0,1);
        ExecuteQuery execquery = new ExecuteQuery(this, strSQL, tableSQL.getParameterValuesOnlyId());
        data = execquery.selectAndSearch(ExecuteQuery.SearchType.FIRST, "", tableSQL.getKeyColumn());

      } catch (Exception e) { 
        log4j.debug("Error getting first element", e);
      }
      if (data!=null) return data;
    }
    return "";
  }

  private String lastElement(VariablesSecureApp vars, TableSQLData tableSQL) throws IOException, ServletException {
    if (tableSQL!=null) {
      String data = null;
      try{
        String strSQL = ModelSQLGeneration.generateSQLonlyId(this, vars, tableSQL, (tableSQL.getTableName() + "." + tableSQL.getKeyColumn() + " AS ID"), new Vector<String>(), new Vector<String>(),0,0);
        ExecuteQuery execquery = new ExecuteQuery(this, strSQL, tableSQL.getParameterValuesOnlyId());
        data = execquery.selectAndSearch(ExecuteQuery.SearchType.LAST, "", tableSQL.getKeyColumn());
      } catch (Exception e) { 
        log4j.error("Error getting last element", e);
      }
      if (data!=null) return data;
    }
    return "";
  }

  private void printPageDataSheet(HttpServletResponse response, VariablesSecureApp vars, String strAD_System_Info_ID, TableSQLData tableSQL)
    throws IOException, ServletException {
    if (log4j.isDebugEnabled()) log4j.debug("Output: dataSheet");

    String strParamSystem_Identifier = vars.getSessionValue(tabId + "|paramSystem_Identifier");
String strParamOB_Version = vars.getSessionValue(tabId + "|paramOB_Version");

    boolean hasSearchCondition=false;
    vars.removeEditionData(tabId);
    hasSearchCondition = (tableSQL.hasInternalFilter() && ("").equals(strParamSystem_Identifier) && ("").equals(strParamOB_Version)) || !(("").equals(strParamSystem_Identifier) || ("%").equals(strParamSystem_Identifier))  || !(("").equals(strParamOB_Version) || ("%").equals(strParamOB_Version)) ;
    String strOffset = vars.getSessionValue(tabId + "|offset");
    String selectedRow = "0";
    if (!strAD_System_Info_ID.equals("")) {
      selectedRow = Integer.toString(getKeyPosition(vars, strAD_System_Info_ID, tableSQL));
    }

    String[] discard={"isNotFiltered","isNotTest"};
    if (hasSearchCondition) discard[0] = new String("isFiltered");
    if (vars.getSessionValue("#ShowTest", "N").equals("Y")) discard[1] = new String("isTest");
    XmlDocument xmlDocument = xmlEngine.readXmlTemplate("org/openbravo/erpWindows/SystemInfo/SystemInfo_Relation", discard).createXmlDocument();

    boolean hasReadOnlyAccess = org.openbravo.erpCommon.utility.WindowAccessData.hasReadOnlyAccess(this, vars.getRole(), tabId);
    ToolBar toolbar = new ToolBar(this, true, vars.getLanguage(), "SystemInfo", false, "document.frmMain.inpadSystemInfoId", "grid", "..", "".equals("Y"), "SystemInfo", strReplaceWith, false, false, false, false, !hasReadOnlyAccess);
    toolbar.setTabId(tabId);
    
    toolbar.setDeleteable(true && !hasReadOnlyAccess);
    toolbar.prepareRelationTemplate("N".equals("Y"), hasSearchCondition, !vars.getSessionValue("#ShowTest", "N").equals("Y"), true, Utility.getContext(this, vars, "ShowAudit", windowId).equals("Y"));
    xmlDocument.setParameter("toolbar", toolbar.toString());



    StringBuffer orderByArray = new StringBuffer();
      vars.setSessionValue(tabId + "|newOrder", "1");
      String positions = vars.getSessionValue(tabId + "|orderbyPositions");
      orderByArray.append("var orderByPositions = new Array(\n");
      if (!positions.equals("")) {
        StringTokenizer tokens=new StringTokenizer(positions, ",");
        boolean firstOrder = true;
        while(tokens.hasMoreTokens()){
          if (!firstOrder) orderByArray.append(",\n");
          orderByArray.append("\"").append(tokens.nextToken()).append("\"");
          firstOrder = false;
        }
      }
      orderByArray.append(");\n");
      String directions = vars.getSessionValue(tabId + "|orderbyDirections");
      orderByArray.append("var orderByDirections = new Array(\n");
      if (!positions.equals("")) {
        StringTokenizer tokens=new StringTokenizer(directions, ",");
        boolean firstOrder = true;
        while(tokens.hasMoreTokens()){
          if (!firstOrder) orderByArray.append(",\n");
          orderByArray.append("\"").append(tokens.nextToken()).append("\"");
          firstOrder = false;
        }
      }
      orderByArray.append(");\n");
//    }

    xmlDocument.setParameter("selectedColumn", "\nvar selectedRow = " + selectedRow + ";\n" + orderByArray.toString());
    xmlDocument.setParameter("directory", "var baseDirectory = \"" + strReplaceWith + "/\";\n");
    xmlDocument.setParameter("windowId", windowId);
    xmlDocument.setParameter("KeyName", "adSystemInfoId");
    xmlDocument.setParameter("language", "defaultLang=\"" + vars.getLanguage() + "\";");
    xmlDocument.setParameter("theme", vars.getTheme());
    //xmlDocument.setParameter("buttonReference", Utility.messageBD(this, "Reference", vars.getLanguage()));
    try {
      WindowTabs tabs = new WindowTabs(this, vars, tabId, windowId, false);
      xmlDocument.setParameter("parentTabContainer", tabs.parentTabs());
      xmlDocument.setParameter("mainTabContainer", tabs.mainTabs());
      xmlDocument.setParameter("childTabContainer", tabs.childTabs());
      String hideBackButton = vars.getGlobalVariable("hideMenu", "#Hide_BackButton", "");
      NavigationBar nav = new NavigationBar(this, vars.getLanguage(), "SystemInfo_Relation.html", "SystemInfo", "W", strReplaceWith, tabs.breadcrumb(), hideBackButton.equals("true"));
      xmlDocument.setParameter("navigationBar", nav.toString());
      LeftTabsBar lBar = new LeftTabsBar(this, vars.getLanguage(), "SystemInfo_Relation.html", strReplaceWith);
      xmlDocument.setParameter("leftTabs", lBar.relationTemplate());
    } catch (Exception ex) {
      throw new ServletException(ex);
    }
    {
      OBError myMessage = vars.getMessage(tabId);
      vars.removeMessage(tabId);
      if (myMessage!=null) {
        xmlDocument.setParameter("messageType", myMessage.getType());
        xmlDocument.setParameter("messageTitle", myMessage.getTitle());
        xmlDocument.setParameter("messageMessage", myMessage.getMessage());
      }
    }


    xmlDocument.setParameter("grid", Utility.getContext(this, vars, "#RecordRange", windowId));
xmlDocument.setParameter("grid_Offset", strOffset);
xmlDocument.setParameter("grid_SortCols", positions);
xmlDocument.setParameter("grid_SortDirs", directions);
xmlDocument.setParameter("grid_Default", selectedRow);


    response.setContentType("text/html; charset=UTF-8");
    PrintWriter out = response.getWriter();
    out.println(xmlDocument.print());
    out.close();
  }

  private void printPageEdit(HttpServletResponse response, HttpServletRequest request, VariablesSecureApp vars,boolean boolNew, String strAD_System_Info_ID, TableSQLData tableSQL)
    throws IOException, ServletException {
    if (log4j.isDebugEnabled()) log4j.debug("Output: edit");
    
    HashMap<String, String> usedButtonShortCuts;
  
    HashMap<String, String> reservedButtonShortCuts;
  
    usedButtonShortCuts = new HashMap<String, String>();
    
    reservedButtonShortCuts = new HashMap<String, String>();
    
    
    
    String strOrderByFilter = vars.getSessionValue(tabId + "|orderby");
    String orderClause = " 1";
    if (strOrderByFilter==null || strOrderByFilter.equals("")) strOrderByFilter = orderClause;
    /*{
      if (!strOrderByFilter.equals("") && !orderClause.equals("")) strOrderByFilter += ", ";
      strOrderByFilter += orderClause;
    }*/
    
    
    String strCommand = null;
    SystemInfoData[] data=null;
    XmlDocument xmlDocument=null;
    FieldProvider dataField = vars.getEditionData(tabId);
    vars.removeEditionData(tabId);
    String strParamSystem_Identifier = vars.getSessionValue(tabId + "|paramSystem_Identifier");
String strParamOB_Version = vars.getSessionValue(tabId + "|paramOB_Version");

    boolean hasSearchCondition=false;
    hasSearchCondition = (tableSQL.hasInternalFilter() && ("").equals(strParamSystem_Identifier) && ("").equals(strParamOB_Version)) || !(("").equals(strParamSystem_Identifier) || ("%").equals(strParamSystem_Identifier))  || !(("").equals(strParamOB_Version) || ("%").equals(strParamOB_Version)) ;

       String strParamSessionDate = vars.getGlobalVariable("inpParamSessionDate", Utility.getTransactionalDate(this, vars, windowId), "");
      String buscador = "";
      String[] discard = {"", "isNotTest"};
      
      if (vars.getSessionValue("#ShowTest", "N").equals("Y")) discard[1] = new String("isTest");
    if (dataField==null) {
      if (!boolNew) {
        discard[0] = new String("newDiscard");
        data = SystemInfoData.selectEdit(this, vars.getSessionValue("#AD_SqlDateTimeFormat"), vars.getLanguage(), strAD_System_Info_ID, Utility.getContext(this, vars, "#User_Client", windowId), Utility.getContext(this, vars, "#AccessibleOrgTree", windowId, accesslevel));
  
        if (!strAD_System_Info_ID.equals("") && (data == null || data.length==0)) {
          response.sendRedirect(strDireccion + request.getServletPath() + "?Command=RELATION");
          return;
        }
        refreshSessionEdit(vars, data);
        strCommand = "EDIT";
      }

      if (data==null || data.length==0) {
        strAD_System_Info_ID = firstElement(vars, tableSQL);
        if (strAD_System_Info_ID.equals("")) {
          response.sendRedirect(strDireccion + request.getServletPath() + "?Command=RELATION");
          return;
        } else {
          data = SystemInfoData.selectEdit(this, vars.getSessionValue("#AD_SqlDateTimeFormat"), vars.getLanguage(), strAD_System_Info_ID, Utility.getContext(this, vars, "#User_Client", windowId), Utility.getContext(this, vars, "#AccessibleOrgTree", windowId, accesslevel));
        }
      }

      if (boolNew || data==null || data.length==0) {
        discard[0] = new String ("editDiscard");
        strCommand = "NEW";
        data = new SystemInfoData[0];
      } else {
        discard[0] = new String ("newDiscard");
      }
    } else {
      if (dataField.getField("adSystemInfoId") == null || dataField.getField("adSystemInfoId").equals("")) {
        discard[0] = new String ("editDiscard");
        strCommand = "NEW";
        boolNew = true;
      } else {
        discard[0] = new String ("newDiscard");
        strCommand = "EDIT";
      }
    }
    
        String strISOPS = SystemInfoData.selectAuxED9749CC067E495FA3D369E65B972450(this);
    vars.setSessionValue(windowId + "|ISOPS", strISOPS);
    
    
    if (dataField==null) {
      if (boolNew || data==null || data.length==0) {
        refreshSessionNew(vars);
        data = SystemInfoData.set("", "0", "0", "Y", Utility.getDefault(this, vars, "Createdby", "", "578DD45CF2BF4D3CA27E4C0EEEF5E5E6", "", dataField), SystemInfoData.selectDef1005400220_0(this, Utility.getDefault(this, vars, "Createdby", "", "578DD45CF2BF4D3CA27E4C0EEEF5E5E6", "", dataField)), Utility.getDefault(this, vars, "Updatedby", "", "578DD45CF2BF4D3CA27E4C0EEEF5E5E6", "", dataField), SystemInfoData.selectDef1005400222_1(this, Utility.getDefault(this, vars, "Updatedby", "", "578DD45CF2BF4D3CA27E4C0EEEF5E5E6", "", dataField)), Utility.getDefault(this, vars, "System_Identifier", "", "578DD45CF2BF4D3CA27E4C0EEEF5E5E6", "", dataField), Utility.getDefault(this, vars, "Isheartbeatactive", "", "578DD45CF2BF4D3CA27E4C0EEEF5E5E6", "N", dataField), Utility.getDefault(this, vars, "Postpone_Date", "", "578DD45CF2BF4D3CA27E4C0EEEF5E5E6", "", dataField), Utility.getDefault(this, vars, "Isproxyrequired", "N", "578DD45CF2BF4D3CA27E4C0EEEF5E5E6", "N", dataField), Utility.getDefault(this, vars, "Proxy_Server", "", "578DD45CF2BF4D3CA27E4C0EEEF5E5E6", "", dataField), Utility.getDefault(this, vars, "Proxy_Port", "", "578DD45CF2BF4D3CA27E4C0EEEF5E5E6", "", dataField), Utility.getDefault(this, vars, "Testproxy", "N", "578DD45CF2BF4D3CA27E4C0EEEF5E5E6", "N", dataField), Utility.getDefault(this, vars, "ANT_Version", "", "578DD45CF2BF4D3CA27E4C0EEEF5E5E6", "", dataField), Utility.getDefault(this, vars, "OB_Version", "", "578DD45CF2BF4D3CA27E4C0EEEF5E5E6", "", dataField), Utility.getDefault(this, vars, "OB_Installmode", "", "578DD45CF2BF4D3CA27E4C0EEEF5E5E6", "", dataField), Utility.getDefault(this, vars, "Servlet_Container", "", "578DD45CF2BF4D3CA27E4C0EEEF5E5E6", "", dataField), Utility.getDefault(this, vars, "Servlet_Container_Version", "", "578DD45CF2BF4D3CA27E4C0EEEF5E5E6", "", dataField), Utility.getDefault(this, vars, "Webserver", "", "578DD45CF2BF4D3CA27E4C0EEEF5E5E6", "", dataField), Utility.getDefault(this, vars, "Webserver_Version", "", "578DD45CF2BF4D3CA27E4C0EEEF5E5E6", "", dataField), Utility.getDefault(this, vars, "Your_Company_Document_Image", "", "578DD45CF2BF4D3CA27E4C0EEEF5E5E6", "", dataField), Utility.getDefault(this, vars, "Your_It_Service_Login_Image", "", "578DD45CF2BF4D3CA27E4C0EEEF5E5E6", "", dataField), Utility.getDefault(this, vars, "Code_Revision", "0", "578DD45CF2BF4D3CA27E4C0EEEF5E5E6", "", dataField), Utility.getDefault(this, vars, "Customization_Allowed", "N", "578DD45CF2BF4D3CA27E4C0EEEF5E5E6", "N", dataField), Utility.getDefault(this, vars, "System_Status", "", "578DD45CF2BF4D3CA27E4C0EEEF5E5E6", "", dataField), Utility.getDefault(this, vars, "Last_Build", "SYSDATE", "578DD45CF2BF4D3CA27E4C0EEEF5E5E6", "", dataField), Utility.getDefault(this, vars, "Last_DBUpdate", "SYSDATE", "578DD45CF2BF4D3CA27E4C0EEEF5E5E6", "", dataField), Utility.getDefault(this, vars, "DB_Checksum", "", "578DD45CF2BF4D3CA27E4C0EEEF5E5E6", "", dataField), Utility.getDefault(this, vars, "Your_Company_Menu_Image", "", "578DD45CF2BF4D3CA27E4C0EEEF5E5E6", "", dataField), Utility.getDefault(this, vars, "Support_Contact", "", "578DD45CF2BF4D3CA27E4C0EEEF5E5E6", "", dataField), Utility.getDefault(this, vars, "Maturity_Update", "500", "578DD45CF2BF4D3CA27E4C0EEEF5E5E6", "", dataField), Utility.getDefault(this, vars, "Maturity_Search", "500", "578DD45CF2BF4D3CA27E4C0EEEF5E5E6", "", dataField), Utility.getDefault(this, vars, "IsProxy_Authenticated", "N", "578DD45CF2BF4D3CA27E4C0EEEF5E5E6", "N", dataField), Utility.getDefault(this, vars, "Proxy_User", "", "578DD45CF2BF4D3CA27E4C0EEEF5E5E6", "", dataField), Utility.getDefault(this, vars, "Proxy_Password", "", "578DD45CF2BF4D3CA27E4C0EEEF5E5E6", "", dataField), Utility.getDefault(this, vars, "Instance_Purpose", "", "578DD45CF2BF4D3CA27E4C0EEEF5E5E6", "", dataField), Utility.getDefault(this, vars, "IsUsageAuditEnabled", "Y", "578DD45CF2BF4D3CA27E4C0EEEF5E5E6", "N", dataField), Utility.getDefault(this, vars, "Change_Instance_Purpose", "Y", "578DD45CF2BF4D3CA27E4C0EEEF5E5E6", "N", dataField), Utility.getDefault(this, vars, "Show_Community_Branding", "Y", "578DD45CF2BF4D3CA27E4C0EEEF5E5E6", "N", dataField), Utility.getDefault(this, vars, "Production_Banner_Image_ID", "", "578DD45CF2BF4D3CA27E4C0EEEF5E5E6", "", dataField), Utility.getDefault(this, vars, "YourCompanyURL", "", "578DD45CF2BF4D3CA27E4C0EEEF5E5E6", "", dataField), Utility.getDefault(this, vars, "ShowForgeLogo", "Y", "578DD45CF2BF4D3CA27E4C0EEEF5E5E6", "N", dataField), Utility.getDefault(this, vars, "Your_Company_Login_Image", "", "578DD45CF2BF4D3CA27E4C0EEEF5E5E6", "", dataField), Utility.getDefault(this, vars, "Your_Company_Big_Image", "", "578DD45CF2BF4D3CA27E4C0EEEF5E5E6", "", dataField));
        
      }
     }
      
    
    String currentOrg = (boolNew?"":(dataField!=null?dataField.getField("adOrgId"):data[0].getField("adOrgId")));
    if (!currentOrg.equals("") && !currentOrg.startsWith("'")) currentOrg = "'"+currentOrg+"'";
    String currentClient = (boolNew?"":(dataField!=null?dataField.getField("adClientId"):data[0].getField("adClientId")));
    if (!currentClient.equals("") && !currentClient.startsWith("'")) currentClient = "'"+currentClient+"'";
    
    boolean hasReadOnlyAccess = org.openbravo.erpCommon.utility.WindowAccessData.hasReadOnlyAccess(this, vars.getRole(), tabId);
    boolean editableTab = (!hasReadOnlyAccess && (currentOrg.equals("") || Utility.isElementInList(Utility.getContext(this, vars, "#User_Org", windowId, accesslevel),currentOrg)) && (currentClient.equals("") || Utility.isElementInList(Utility.getContext(this, vars, "#User_Client", windowId, accesslevel), currentClient)));
    if (editableTab)
      xmlDocument = xmlEngine.readXmlTemplate("org/openbravo/erpWindows/SystemInfo/SystemInfo_Edition",discard).createXmlDocument();
    else
      xmlDocument = xmlEngine.readXmlTemplate("org/openbravo/erpWindows/SystemInfo/SystemInfo_NonEditable",discard).createXmlDocument();

    xmlDocument.setParameter("tabId", tabId);
    ToolBar toolbar = new ToolBar(this, editableTab, vars.getLanguage(), "SystemInfo", (strCommand.equals("NEW") || boolNew || (dataField==null && (data==null || data.length==0))), "document.frmMain.inpadSystemInfoId", "", "..", "".equals("Y"), "SystemInfo", strReplaceWith, true, false, false, Utility.hasTabAttachments(this, vars, tabId, strAD_System_Info_ID), !hasReadOnlyAccess);
    toolbar.setTabId(tabId);
    toolbar.setDeleteable(true);
    toolbar.prepareEditionTemplate("N".equals("Y"), hasSearchCondition, vars.getSessionValue("#ShowTest", "N").equals("Y"), "SR", Utility.getContext(this, vars, "ShowAudit", windowId).equals("Y"));
    xmlDocument.setParameter("toolbar", toolbar.toString());

    // set updated timestamp to manage locking mechanism
    if (!boolNew) {
      xmlDocument.setParameter("updatedTimestamp", (dataField != null ? dataField
          .getField("updatedTimeStamp") : data[0].getField("updatedTimeStamp")));
    }
    
    boolean concurrentSave = vars.getSessionValue(tabId + "|concurrentSave").equals("true");
    if (concurrentSave) {
      //after concurrent save error, force autosave
      xmlDocument.setParameter("autosave", "Y");
    } else {
      xmlDocument.setParameter("autosave", "N");
    }
    vars.removeSessionValue(tabId + "|concurrentSave");

    try {
      WindowTabs tabs = new WindowTabs(this, vars, tabId, windowId, true, (strCommand.equalsIgnoreCase("NEW")));
      xmlDocument.setParameter("parentTabContainer", tabs.parentTabs());
      xmlDocument.setParameter("mainTabContainer", tabs.mainTabs());
      // if (!strAD_System_Info_ID.equals("")) xmlDocument.setParameter("childTabContainer", tabs.childTabs(false));
	  // else xmlDocument.setParameter("childTabContainer", tabs.childTabs(true));
	  xmlDocument.setParameter("childTabContainer", tabs.childTabs(false));
	  String hideBackButton = vars.getGlobalVariable("hideMenu", "#Hide_BackButton", "");
      NavigationBar nav = new NavigationBar(this, vars.getLanguage(), "SystemInfo_Relation.html", "SystemInfo", "W", strReplaceWith, tabs.breadcrumb(), hideBackButton.equals("true"), !concurrentSave);
      xmlDocument.setParameter("navigationBar", nav.toString());
      LeftTabsBar lBar = new LeftTabsBar(this, vars.getLanguage(), "SystemInfo_Relation.html", strReplaceWith);
      xmlDocument.setParameter("leftTabs", lBar.editionTemplate(strCommand.equals("NEW")));
    } catch (Exception ex) {
      throw new ServletException(ex);
    }
		
        xmlDocument.setParameter("ISOPS", strISOPS);
    
    
    xmlDocument.setParameter("commandType", strCommand);
    xmlDocument.setParameter("buscador",buscador);
    xmlDocument.setParameter("windowId", windowId);
    xmlDocument.setParameter("changed", "");
    xmlDocument.setParameter("language", "defaultLang=\"" + vars.getLanguage() + "\";");
    xmlDocument.setParameter("theme", vars.getTheme());
    final String strMappingName = Utility.getTabURL(tabId, "E", false);
    xmlDocument.setParameter("mappingName", strMappingName);
    xmlDocument.setParameter("confirmOnChanges", Utility.getJSConfirmOnChanges(vars, windowId));
    //xmlDocument.setParameter("buttonReference", Utility.messageBD(this, "Reference", vars.getLanguage()));

    xmlDocument.setParameter("paramSessionDate", strParamSessionDate);

    xmlDocument.setParameter("directory", "var baseDirectory = \"" + strReplaceWith + "/\";\n");
    OBError myMessage = vars.getMessage(tabId);
    vars.removeMessage(tabId);
    if (myMessage!=null) {
      xmlDocument.setParameter("messageType", myMessage.getType());
      xmlDocument.setParameter("messageTitle", myMessage.getTitle());
      xmlDocument.setParameter("messageMessage", myMessage.getMessage());
    }
    xmlDocument.setParameter("displayLogic", getDisplayLogicContext(vars, boolNew));
    
    //Encrypted fields
    if (data!=null && data.length>0) {
      data[0].proxyPassword="";
    }
    
    
     if (dataField==null) {
      xmlDocument.setData("structure1",data);
      
    } else {
      
        FieldProvider[] dataAux = new FieldProvider[1];
        dataAux[0] = dataField;
        
        xmlDocument.setData("structure1",dataAux);
      
    }
    
      
   
    try {
      ComboTableData comboTableData = null;
comboTableData = new ComboTableData(vars, this, "17", "Instance_Purpose", "60E231391A7348DDA7171E780F62EF99", "", Utility.getReferenceableOrg(vars, (dataField!=null?dataField.getField("adOrgId"):data[0].getField("adOrgId").equals("")?vars.getOrg():data[0].getField("adOrgId"))), Utility.getContext(this, vars, "#User_Client", windowId), 0);
Utility.fillSQLParameters(this, vars, (dataField==null?data[0]:dataField), comboTableData, windowId, (dataField==null?data[0].getField("instancePurpose"):dataField.getField("instancePurpose")));
xmlDocument.setData("reportInstance_Purpose","liststructure", comboTableData.select(!strCommand.equals("NEW")));
comboTableData = null;
xmlDocument.setParameter("Change_Instance_Purpose_BTNname", Utility.getButtonName(this, vars, "91F596DF68F18B97E040007F010051BE", "Change_Instance_Purpose_linkBTN", usedButtonShortCuts, reservedButtonShortCuts));boolean modalChange_Instance_Purpose = org.openbravo.erpCommon.utility.Utility.isModalProcess("BB35E1D5CE2648EB8C955DD022E994DA"); 
xmlDocument.setParameter("Change_Instance_Purpose_Modal", modalChange_Instance_Purpose?"true":"false");
String strCurrentImageURLProduction_Banner_Image_ID = (dataField==null?data[0].getField("productionBannerImageId"):dataField.getField("productionBannerImageId"));
if (strCurrentImageURLProduction_Banner_Image_ID==null || strCurrentImageURLProduction_Banner_Image_ID.equals("")){
  xmlDocument.setParameter("Production_Banner_Image_IDClass", "Image_NotAvailable_medium");
}

comboTableData = new ComboTableData(vars, this, "17", "System_Status", "865D46B9A1C148D1A119F2F0F7F55589", "", Utility.getReferenceableOrg(vars, (dataField!=null?dataField.getField("adOrgId"):data[0].getField("adOrgId").equals("")?vars.getOrg():data[0].getField("adOrgId"))), Utility.getContext(this, vars, "#User_Client", windowId), 0);
Utility.fillSQLParameters(this, vars, (dataField==null?data[0]:dataField), comboTableData, windowId, (dataField==null?data[0].getField("systemStatus"):dataField.getField("systemStatus")));
xmlDocument.setData("reportSystem_Status","liststructure", comboTableData.select(!strCommand.equals("NEW")));
comboTableData = null;
String strCurrentImageURLYour_Company_Login_Image = (dataField==null?data[0].getField("yourCompanyLoginImage"):dataField.getField("yourCompanyLoginImage"));
if (strCurrentImageURLYour_Company_Login_Image==null || strCurrentImageURLYour_Company_Login_Image.equals("")){
  xmlDocument.setParameter("Your_Company_Login_ImageClass", "Image_NotAvailable_medium");
}

String strCurrentImageURLYour_It_Service_Login_Image = (dataField==null?data[0].getField("yourItServiceLoginImage"):dataField.getField("yourItServiceLoginImage"));
if (strCurrentImageURLYour_It_Service_Login_Image==null || strCurrentImageURLYour_It_Service_Login_Image.equals("")){
  xmlDocument.setParameter("Your_It_Service_Login_ImageClass", "Image_NotAvailable_medium");
}

String strCurrentImageURLYour_Company_Menu_Image = (dataField==null?data[0].getField("yourCompanyMenuImage"):dataField.getField("yourCompanyMenuImage"));
if (strCurrentImageURLYour_Company_Menu_Image==null || strCurrentImageURLYour_Company_Menu_Image.equals("")){
  xmlDocument.setParameter("Your_Company_Menu_ImageClass", "Image_NotAvailable_medium");
}

String strCurrentImageURLYour_Company_Big_Image = (dataField==null?data[0].getField("yourCompanyBigImage"):dataField.getField("yourCompanyBigImage"));
if (strCurrentImageURLYour_Company_Big_Image==null || strCurrentImageURLYour_Company_Big_Image.equals("")){
  xmlDocument.setParameter("Your_Company_Big_ImageClass", "Image_NotAvailable_medium");
}

String strCurrentImageURLYour_Company_Document_Image = (dataField==null?data[0].getField("yourCompanyDocumentImage"):dataField.getField("yourCompanyDocumentImage"));
if (strCurrentImageURLYour_Company_Document_Image==null || strCurrentImageURLYour_Company_Document_Image.equals("")){
  xmlDocument.setParameter("Your_Company_Document_ImageClass", "Image_NotAvailable_medium");
}

xmlDocument.setParameter("Created_Format", vars.getSessionValue("#AD_SqlDateTimeFormat"));xmlDocument.setParameter("Created_Maxlength", Integer.toString(vars.getSessionValue("#AD_SqlDateTimeFormat").length()));
xmlDocument.setParameter("Updated_Format", vars.getSessionValue("#AD_SqlDateTimeFormat"));xmlDocument.setParameter("Updated_Maxlength", Integer.toString(vars.getSessionValue("#AD_SqlDateTimeFormat").length()));
xmlDocument.setParameter("Last_Build_Format", vars.getSessionValue("#AD_SqlDateTimeFormat"));xmlDocument.setParameter("Last_Build_Maxlength", Integer.toString(vars.getSessionValue("#AD_SqlDateTimeFormat").length()));
xmlDocument.setParameter("Postpone_Date_Format", vars.getSessionValue("#AD_SqlDateFormat"));
xmlDocument.setParameter("Last_DBUpdate_Format", vars.getSessionValue("#AD_SqlDateTimeFormat"));xmlDocument.setParameter("Last_DBUpdate_Maxlength", Integer.toString(vars.getSessionValue("#AD_SqlDateTimeFormat").length()));
    } catch (Exception ex) {
      ex.printStackTrace();
      throw new ServletException(ex);
    }

    xmlDocument.setParameter("scriptOnLoad", getShortcutScript(usedButtonShortCuts, reservedButtonShortCuts));
    
    final String refererURL = vars.getSessionValue(tabId + "|requestURL");
    vars.removeSessionValue(tabId + "|requestURL");
    if(!refererURL.equals("")) {
    	final Boolean failedAutosave = (Boolean) vars.getSessionObject(tabId + "|failedAutosave");
		vars.removeSessionValue(tabId + "|failedAutosave");
    	if(failedAutosave != null && failedAutosave) {
    		final String jsFunction = "continueUserAction('"+refererURL+"');";
    		xmlDocument.setParameter("failedAutosave", jsFunction);
    	}
    }

    if (strCommand.equalsIgnoreCase("NEW")) {
      vars.removeSessionValue(tabId + "|failedAutosave");
      vars.removeSessionValue(strMappingName + "|hash");
    }

    response.setContentType("text/html; charset=UTF-8");
    PrintWriter out = response.getWriter();
    out.println(xmlDocument.print());
    out.close();
  }

  private void printPageButtonFS(HttpServletResponse response, VariablesSecureApp vars, String strProcessId, String path) throws IOException, ServletException {
    log4j.debug("Output: Frames action button");
    response.setContentType("text/html; charset=UTF-8");
    PrintWriter out = response.getWriter();
    XmlDocument xmlDocument = xmlEngine.readXmlTemplate(
        "org/openbravo/erpCommon/ad_actionButton/ActionButtonDefaultFrames").createXmlDocument();
    xmlDocument.setParameter("processId", strProcessId);
    xmlDocument.setParameter("trlFormType", "PROCESS");
    xmlDocument.setParameter("language", "defaultLang = \"" + vars.getLanguage() + "\";\n");
    xmlDocument.setParameter("type", strDireccion + path);
    out.println(xmlDocument.print());
    out.close();
  }





    private String getDisplayLogicContext(VariablesSecureApp vars, boolean isNew) throws IOException, ServletException {
      log4j.debug("Output: Display logic context fields");
      String result = "var strShowAudit=\"" +(isNew?"N":Utility.getContext(this, vars, "ShowAudit", windowId)) + "\";\n";
      return result;
    }


    private String getReadOnlyLogicContext(VariablesSecureApp vars) throws IOException, ServletException {
      log4j.debug("Output: Read Only logic context fields");
      String result = "";
      return result;
    }


    void printPageButtonProxy_Password(HttpServletRequest request, HttpServletResponse response, VariablesSecureApp vars, String strAD_System_Info_ID)
    throws IOException, ServletException {
      log4j.debug("Output: Button Encrypted Proxy_Password");
      response.setContentType("text/html; charset=UTF-8");
      PrintWriter out = response.getWriter();
      XmlDocument xmlDocument = xmlEngine.readXmlTemplate("org/openbravo/erpCommon/ad_actionButton/EncryptedButtons").createXmlDocument();

      if (SystemInfoData.checkproxyPassword(this, strAD_System_Info_ID).equals("0")) {
        bdErrorGeneralPopUp(request, response,Utility.messageBD(this,"Error", vars.getLanguage()),Utility.messageBD(this,"SaveAndTry", vars.getLanguage()));
      } else {
        xmlDocument.setParameter("theme", vars.getTheme());
        xmlDocument.setParameter("realName", "Proxy_Password");
        xmlDocument.setParameter("key", strAD_System_Info_ID);
        xmlDocument.setParameter("keyName", "adSystemInfoId");
        xmlDocument.setParameter("form", "SystemInfo_Edition.html");
        xmlDocument.setParameter("fieldId", "8C84C8C20427A648E040007F010137E1");
        xmlDocument.setParameter("fieldLabel", Utility.messageBD(this, "Proxy_Password", vars.getLanguage()));
        xmlDocument.setParameter("fieldColumnName", "Proxy_Password");
        
        xmlDocument.setParameter("language", "defaultLang=\"" + vars.getLanguage() + "\";");
        xmlDocument.setParameter("directory", "var baseDirectory = \"" + strReplaceWith + "/\";\n");
        xmlDocument.setParameter("cancel", Utility.messageBD(this, "Cancel", vars.getLanguage()));
        xmlDocument.setParameter("ok", Utility.messageBD(this, "OK", vars.getLanguage()));
  
        out.println(xmlDocument.print());
      }
      out.close();
    }


 
  private String getShortcutScript( HashMap<String, String> usedButtonShortCuts, HashMap<String, String> reservedButtonShortCuts){
    StringBuffer shortcuts = new StringBuffer();
    shortcuts.append(" function buttonListShorcuts() {\n");
    Iterator<String> ik = usedButtonShortCuts.keySet().iterator();
    Iterator<String> iv = usedButtonShortCuts.values().iterator();
    while(ik.hasNext() && iv.hasNext()){
      shortcuts.append("  keyArray[keyArray.length] = new keyArrayItem(\"").append(ik.next()).append("\", \"").append(iv.next()).append("\", null, \"altKey\", false, \"onkeydown\");\n");
    }
    shortcuts.append(" return true;\n}");
    return shortcuts.toString();
  }
  
  private int saveRecord(VariablesSecureApp vars, OBError myError, char type) throws IOException, ServletException {
    SystemInfoData data = null;
    int total = 0;
    if (org.openbravo.erpCommon.utility.WindowAccessData.hasReadOnlyAccess(this, vars.getRole(), tabId)) {
        OBError newError = Utility.translateError(this, vars, vars.getLanguage(), Utility.messageBD(this, "NoWriteAccess", vars.getLanguage()));
        myError.setError(newError);
        vars.setMessage(tabId, myError);
    }
    else {
        Connection con = null;
        try {
            con = this.getTransactionConnection();
            data = getEditVariables(con, vars);
            data.dateTimeFormat = vars.getSessionValue("#AD_SqlDateTimeFormat");            
            String strSequence = "";
            if(type == 'I') {                
        strSequence = SequenceIdData.getUUID();
                if(log4j.isDebugEnabled()) log4j.debug("Sequence: " + strSequence);
                data.adSystemInfoId = strSequence;  
            }
            if (Utility.isElementInList(Utility.getContext(this, vars, "#User_Client", windowId, accesslevel),data.adClientId)  && Utility.isElementInList(Utility.getContext(this, vars, "#User_Org", windowId, accesslevel),data.adOrgId)){
		     if(type == 'I') {
		       total = data.insert(con, this);
		     } else {
		       //Check the version of the record we are saving is the one in DB
		       if (SystemInfoData.getCurrentDBTimestamp(this, data.adSystemInfoId).equals(
                vars.getStringParameter("updatedTimestamp"))) {
                total = data.update(con, this);
               } else {
                 myError.setMessage(Replace.replace(Replace.replace(Utility.messageBD(this,
                    "SavingModifiedRecord", vars.getLanguage()), "\\n", "<br/>"), "&quot;", "\""));
                 myError.setType("Error");
                 vars.setSessionValue(tabId + "|concurrentSave", "true");
               } 
		     }		            
          
            }
                else {
            OBError newError = Utility.translateError(this, vars, vars.getLanguage(), Utility.messageBD(this, "NoWriteAccess", vars.getLanguage()));
            myError.setError(newError);            
          }
          releaseCommitConnection(con);
        } catch(Exception ex) {
            OBError newError = Utility.translateError(this, vars, vars.getLanguage(), ex.getMessage());
            myError.setError(newError);   
            try {
              releaseRollbackConnection(con);
            } catch (final Exception e) { //do nothing 
            }           
        }
            
        if (myError.isEmpty() && total == 0) {
            OBError newError = Utility.translateError(this, vars, vars.getLanguage(), "@CODE=DBExecuteError");
            myError.setError(newError);
        }
        vars.setMessage(tabId, myError);
            
        if(!myError.isEmpty()){
            if(data != null ) {
                if(type == 'I') {            			
                    data.adSystemInfoId = "";
                }
                else {                    
                    
                }
                vars.setEditionData(tabId, data);
            }            	
        }
        else {
            vars.setSessionValue(windowId + "|AD_System_Info_ID", data.adSystemInfoId);
        }
    }
    return total;
  }

  public String getServletInfo() {
    return "Servlet SystemInfo. This Servlet was made by Wad constructor";
  } // End of getServletInfo() method
}
