
package org.openbravo.erpWindows.WindowsTabsandFields;

import org.openbravo.base.exception.OBException;
import org.openbravo.base.filter.IsIDFilter;
import org.openbravo.base.secureApp.HttpSecureAppServlet;
import org.openbravo.base.secureApp.VariablesSecureApp;
import org.openbravo.erpCommon.businessUtility.WindowTabs;
import org.openbravo.erpCommon.utility.*;
import org.openbravo.xmlEngine.XmlDocument;
import org.openbravo.exception.*;
import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.util.StringTokenizer;
import java.sql.Connection;
import java.sql.SQLException;

public class GridSequence extends HttpSecureAppServlet {
  private static final long serialVersionUID = 1L;
  protected static final String windowId = "102";
  protected static final String tabId = "6456FDAA469148E580B92126863C5A20";
  protected static final double SUBTABS_COL_SIZE = 15;
  protected static final int accesslevel = 4;
  private static final String moduleId = "0";
  
  @Override
  public void init(ServletConfig config) {
    setClassInfo("W", tabId, moduleId);
    super.init(config);
  }

  public void doPost (HttpServletRequest request, HttpServletResponse response) throws IOException,ServletException {
    VariablesSecureApp vars = new VariablesSecureApp(request);
    Boolean saveRequest = (Boolean) request.getAttribute("autosave");
    if (saveRequest != null && saveRequest) {
      boolean editableTab = Utility.canUpdate(this, vars, Utility.getContext(this, vars,
          "#AD_Client_ID", windowId), Utility.getContext(this, vars, "#AD_Org_ID", windowId),
          windowId);

      OBError myError = new OBError();

      if (editableTab) {
        boolean success = saveRecord(vars, myError);
        if (!myError.isEmpty()) {
          vars.setMessage(tabId, myError);
        }
        if (!success) {
          throw new OBException(myError.getMessage());
        }

      }
      vars.setSessionValue(request.getParameter("mappingName") + "|hash", vars.getPostDataHash());
      vars.setSessionValue(tabId + "|Header.view", "EDIT");

      return;
    }
    
    vars.removeSessionValue(Utility.getTabURL(tabId, "E", false) + "|hash");
    vars.setSessionObject(tabId + "|failedAutosave", false);
    if (vars.commandIn("DEFAULT", "NEW")) {
      String strPAD_Tab_ID = vars.getGlobalVariable("inpadTabId", windowId + "|AD_Tab_ID");

      String strAD_Field_ID = vars.getGlobalVariable("inpadFieldId", windowId + "|AD_Field_ID", "");

      printPageDataSheet(response, vars, strPAD_Tab_ID, strAD_Field_ID);
    } else if (vars.commandIn("TAB")) {
      String strPAD_Tab_ID = vars.getGlobalVariable("inpadTabId", windowId + "|AD_Tab_ID");
      refreshParentSession(vars, strPAD_Tab_ID);


      vars.removeSessionValue(windowId + "|AD_Field_ID");
      printPageDataSheet(response, vars, strPAD_Tab_ID, "");
    } else if (vars.getCommand().startsWith("SAVE")) {
      if (!Utility.canUpdate(this, vars, Utility.getContext(this, vars, "#AD_Client_ID", windowId), Utility.getContext(this, vars, "#AD_Org_ID", windowId), windowId)) {
        bdError(request, response, "AccessTableNoUpdate", vars.getLanguage());
      } else {
        OBError myError = new OBError();
        if (saveRecord(vars, myError)) {
          if (myError.isEmpty()) {
            myError.setType("Success");
            myError.setMessage(Utility.messageBD(this, "Success", vars.getLanguage()));
          }
        }
        vars.setMessage(tabId, myError);
        response.sendRedirect(strDireccion + request.getServletPath());
      }
    } else pageError(response);
  }
  
   private boolean saveRecord(VariablesSecureApp vars, OBError myError) throws ServletException,
      IOException {
      boolean error = false;
            String strPAD_Tab_ID = vars.getGlobalVariable("inpadTabId", windowId + "|AD_Tab_ID");
      GridSequenceData data = getEditVariables(vars, strPAD_Tab_ID);
      
      
      Connection conn = null;
        try {
          conn = this.getTransactionConnection();
          data.updateN(conn, this);
          if (data.shown.startsWith("(")) data.shown = data.shown.substring(1, data.shown.length()-1);
          if (!data.shown.equals("")) {
            StringTokenizer st = new StringTokenizer(data.shown, ",", false);
            
            int i = 0;
            int size = st.countTokens();
            GridSequenceData dataShown[] = new GridSequenceData[size];
            
            while (st.hasMoreTokens()) {
              dataShown[i] = getEditVariables(vars, strPAD_Tab_ID);
              dataShown[i].adFieldId = st.nextToken().trim();
              if (dataShown[i].adFieldId.startsWith("'")) dataShown[i].adFieldId = dataShown[i].adFieldId.substring(1, dataShown[i].adFieldId.length()-1);
              dataShown[i].seqnoParam = GridSequenceData.selectSeqNo(this, dataShown[i].adFieldId);
              dataShown[i].isindevelopment = GridSequenceData.selectInDevelopmentModule(this, dataShown[i].adFieldId);
              i++;
            }

            //modify only in case the field's module is in development
            int start=0;
            int end=0;
            int seqno=0;
            int maxSeqno=0;
            boolean templateInDev = GridSequenceData.isTemplateInDev(this);
            
            while (end < size) {
              // start-end define the first and last element to sort
              start = end;
    
              // look for the first non-sorted item, and set it as start
              boolean sorted = true;
              while (start < size && sorted) {
                if (start < size - 1) {
                  sorted = !(dataShown[start].seqnoParam.isEmpty() && !dataShown[start + 1].seqnoParam
                      .isEmpty());
                  sorted = sorted
                      && !(dataShown[start].seqnoParam.isEmpty() && dataShown[start + 1].seqnoParam
                          .isEmpty());
                  if (sorted && !dataShown[start].seqnoParam.isEmpty()
                      && !dataShown[start + 1].seqnoParam.isEmpty()) {
                    sorted = Integer.parseInt(dataShown[start].seqnoParam) < Integer
                        .parseInt(dataShown[start + 1].seqnoParam);
                  }
                } else if (start == size - 1) {
                  // In case a single element, treat it as not sorted
                  sorted = false;
                }
    
                if (sorted) {
                  start++;
                }
              }
    
              // Start now contains the first unsorted element, if it is not in dev, move start forward
              while (start < size && !templateInDev && dataShown[start].isindevelopment.equals("N")) {
                start++;
              }
    
              // Looking for end. It will be the last unsorted element
              end = start + 1;
              if (end > size) {
                end = size;
              }
              if (start > 0 && !dataShown[start - 1].seqnoParam.isEmpty()) {
                seqno = new Integer(dataShown[start - 1].seqnoParam).intValue();
              }
              while (end < size && !sorted
                  && (templateInDev || dataShown[end].isindevelopment.equals("Y"))) {
    
                sorted = dataShown[end].seqnoParam.isEmpty() && !dataShown[end].seqnoParam.isEmpty();
                sorted = sorted
                    || end + 1 < size
                    && !(dataShown[end].seqnoParam.isEmpty() || dataShown[end + 1].seqnoParam.isEmpty())
                    && Integer.parseInt(dataShown[end].seqnoParam) < Integer
                        .parseInt(dataShown[end + 1].seqnoParam);
    
                if (end + 1 < size && !dataShown[end].seqnoParam.isEmpty()) {
                  maxSeqno = new Integer(dataShown[end].seqnoParam).intValue();
    
                  if (sorted && maxSeqno - seqno <= end - start) {
                    // It is sorted, it should be the end point, but there's no place for sorting, set
                    // it as unsorted to look for more place if possible.
                    sorted = false;
                  }
                }
                if (!sorted) {
                  end++;
                }
              }
    
              if (maxSeqno == 0 && end < size) {
                maxSeqno = new Integer(dataShown[end].seqnoParam).intValue();
              }
    
              log4j.debug("Sorting from position:" + start + " to:" + end + ". Size:" + size);
    
              if ((start > 0) && (end < size) && (seqno >= maxSeqno) && !(start == end && end == size)) {
                myError.setType("Error");
                myError.setTitle(Utility.messageBD(this, "Error", vars.getLanguage()));
                myError.setMessage(Utility.messageBD(this, "CannotReorderNotDevModules", vars
                    .getLanguage()));
                releaseRollbackConnection(conn);
                error = true;
                break;
              }
              if (end == size)
                maxSeqno = -1; // no limit
              int add = (maxSeqno == -1) ? 10 : new Float(((maxSeqno - seqno) / (end - start + 1)))
                  .intValue();
              for (int j = start; j < end; j++) {
                if (maxSeqno == -1 || seqno < maxSeqno)
                  seqno += add;
                else {
                  myError.setType("Warning");
                  myError.setTitle(Utility.messageBD(this, "Warning", vars.getLanguage()));
                  myError.setMessage(Utility.messageBD(this, "NotAllOrdered", vars.getLanguage()));
                }
                dataShown[j].seqnoParam = Integer.toString(seqno);
              }
            }
    
            for (int j = 0; !error && j < dataShown.length; j++) {
              if (j < dataShown.length - 1
                  && (dataShown[j].seqnoParam.isEmpty() || dataShown[j + 1].seqnoParam.isEmpty() || Integer
                      .parseInt(dataShown[j].seqnoParam) > Integer
                      .parseInt(dataShown[j + 1].seqnoParam))) {
                myError.setType("Error");
                myError.setTitle(Utility.messageBD(this, "Error", vars.getLanguage()));
                myError.setMessage(Utility.messageBD(this, "CannotReorderNotDevModules", vars
                    .getLanguage()));
                releaseRollbackConnection(conn);
                error = true;
                break;
              }
              dataShown[j].updateY(conn, this);
            }
          }
          if (!error) {
            releaseCommitConnection(conn);
          }
          return !error;
        } catch (NoConnectionAvailableException ex) {
          myError.setType("Error");
          myError.setMessage(ex.getMessage());
          log4j.error("Error saving sequence", ex);
          return false;
        } catch (SQLException ex2) {
          try {
            releaseRollbackConnection(conn);
          } catch (Exception ignored) {}
          ServletException se = new ServletException("@CODE=" + Integer.toString(ex2.getErrorCode()) + "@" + ex2.getMessage());
          myError.setType("Error");
          myError.setMessage(Utility.parseTranslation(this, vars, vars.getLanguage(), se.getMessage()));
          return false;
        } catch (ServletException e) {
          try {
            releaseRollbackConnection(conn);
          } catch (Exception ignored) {}
          myError.setType("Error");
          myError.setMessage(Utility.parseTranslation(this, vars, vars.getLanguage(), e.getMessage()));
          return false;
        } catch (Exception exc) {
          try {
            releaseRollbackConnection(conn);
          } catch (Exception ignored) {}
          throw new ServletException("@CODE=@" + exc.getMessage(), exc);
        }
   }

  GridSequenceData getEditVariables(VariablesSecureApp vars, String strPAD_Tab_ID) throws IOException,ServletException {
    GridSequenceData data = new GridSequenceData();
    data.adFieldId = vars.getInStringParameter("inpShown", IsIDFilter.instance);
      data.shown = vars.getInStringParameter("inpShown", IsIDFilter.instance);
      data.createdby = vars.getUser();
      data.updatedby = vars.getUser();

      data.adTabId = vars.getGlobalVariable("inpadTabId", windowId + "|AD_Tab_ID");


    return data;
  }

    void refreshParentSession(VariablesSecureApp vars, String strPAD_Tab_ID) throws IOException,ServletException {
      TabData[] data = TabData.selectEdit(this, vars.getSessionValue("#AD_SqlDateTimeFormat"), vars.getLanguage(), strPAD_Tab_ID, vars.getSessionValue(windowId + "|AD_Window_ID"), Utility.getContext(this, vars, "#User_Client", windowId, accesslevel), Utility.getContext(this, vars, "#AccessibleOrgTree", windowId, accesslevel));
      if (data==null || data.length==0) return;
          vars.setSessionValue(windowId + "|AD_Table_ID", data[0].adTableId);    vars.setSessionValue(windowId + "|AD_Tab_ID", data[0].adTabId);    vars.setSessionValue(windowId + "|AD_Client_ID", data[0].adClientId);    vars.setSessionValue(windowId + "|AD_Org_ID", data[0].adOrgId);
      
    }


  void printPageDataSheet(HttpServletResponse response, VariablesSecureApp vars, String strPAD_Tab_ID, String strAD_Field_ID)
    throws IOException, ServletException {
    if (log4j.isDebugEnabled()) log4j.debug("Output: dataSheet");
    XmlDocument xmlDocument=null;

      GridSequenceData[] data = GridSequenceData.select(this, vars.getLanguage(), Utility.getContext(this, vars, "#User_Client", windowId, accesslevel), Utility.getContext(this, vars, "#AccessibleOrgTree", windowId, accesslevel), strPAD_Tab_ID);

      GridSequenceData[] data2 = GridSequenceData.selectNotShown(this, vars.getLanguage(), Utility.getContext(this, vars, "#User_Client", windowId, accesslevel), Utility.getContext(this, vars, "#AccessibleOrgTree", windowId, accesslevel), strPAD_Tab_ID);

      String[] discard={"isNotTest"};
      if (vars.getSessionValue("#ShowTest", "N").equals("Y")) discard[0] = new String("isTest");
      xmlDocument = xmlEngine.readXmlTemplate("org/openbravo/erpWindows/WindowsTabsandFields/GridSequence_Relation", discard).createXmlDocument();

    xmlDocument.setParameter("keyParent", strPAD_Tab_ID);
    xmlDocument.setParameter("showName", Utility.messageBD(this, "Grid_Seqno", vars.getLanguage()));

    ToolBar toolbar = new ToolBar(this, vars.getLanguage(), "GridSequence", false, "document.frmMain.inpadFieldId", "", "", "".equals("Y"), "WindowsTabsandFields", strReplaceWith, false);
    toolbar.prepareSortableTemplate(vars.getSessionValue("#ShowTest", "N").equals("Y"));
    xmlDocument.setParameter("toolbar", toolbar.toString());

    try {
      WindowTabs tabs = new WindowTabs(this, vars, tabId, windowId, true, true);
      xmlDocument.setParameter("parentTabContainer", tabs.parentTabs());
      xmlDocument.setParameter("mainTabContainer", tabs.mainTabs());
      xmlDocument.setParameter("childTabContainer", tabs.childTabs());
      NavigationBar nav = new NavigationBar(this, vars.getLanguage(), "GridSequence_Relation.html", "WindowsTabsandFields", "W", strReplaceWith, tabs.breadcrumb());
      xmlDocument.setParameter("navigationBar", nav.toString());
      xmlDocument.setParameter("theme", vars.getTheme());
      LeftTabsBar lBar = new LeftTabsBar(this, vars.getLanguage(), "GridSequence_Relation.html", strReplaceWith);
      xmlDocument.setParameter("leftTabs", lBar.manualTemplate());
    } catch (Exception ex) {
      throw new ServletException(ex);
    }
    try {
      KeyMap key = new KeyMap(this, tabId, windowId);
      xmlDocument.setParameter("keyMap", key.getSortTabKeyMaps());
    } catch (Exception ex) {
      throw new ServletException(ex);
    }

    {
      OBError myMessage = vars.getMessage(tabId);
      vars.removeMessage(tabId);
      if (myMessage!=null) {
        xmlDocument.setParameter("messageType", myMessage.getType());
        xmlDocument.setParameter("messageTitle", myMessage.getTitle());
        xmlDocument.setParameter("messageMessage", myMessage.getMessage());
      }
    }

    xmlDocument.setParameter("directory", "var baseDirectory = \"" + strReplaceWith + "/\";\n");
    xmlDocument.setParameter("windowId", windowId);
    xmlDocument.setParameter("KeyName", "adFieldId");
    xmlDocument.setParameter("language", "defaultLang=\"" + vars.getLanguage() + "\";");
    xmlDocument.setData("structure1", data2);
    xmlDocument.setData("structure2", data);
    final String strMappingName = Utility.getTabURL(tabId, "E", false);
    xmlDocument.setParameter("mappingName", strMappingName);
    xmlDocument.setParameter("confirmOnChanges", Utility.getJSConfirmOnChanges(vars, windowId));
    if (vars.getLanguage().equals("en_US")) xmlDocument.setParameter("parent", GridSequenceData.selectParent(this, vars.getLanguage(), strPAD_Tab_ID));
    else xmlDocument.setParameter("parent", GridSequenceData.selectParentTrl(this, vars.getLanguage(), strPAD_Tab_ID));

    response.setContentType("text/html; charset=UTF-8");
    PrintWriter out = response.getWriter();
    out.println(xmlDocument.print());
    out.close();
  }

  public String getServletInfo() {
    return "Servlet GridSequence. This Servlet was made by Wad constructor";
  } // fin del método getServletInfo()
}
